Wt: Wt::WSocketNotifier Class Reference

Wt 3.3.0

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes

- Class List
- Class Hierarchy
- Class Members

Public Types | Public Member Functions
Wt::WSocketNotifier Class Reference

A utility class for asynchronous notification of socket activity. More...

`#include <Wt/WSocketNotifier>`

Inheritance diagram for Wt::WSocketNotifier:
[legend]

List of all members.

## Public Types
enum | Type { Read, Write, Exception }
| Enumeration that event type. More...
## Public Member Functions
| WSocketNotifier (int socket, Type type, WObject *parent=0)
| Creates a new socket notifier.
| ~WSocketNotifier ()
| Destructor.
int | socket () const
| Returns the socket.
Type | type () const
| Returns the event type.
void | setEnabled (bool enabled)
| Enables or disable the notifier.
bool | isEnabled () const
| Returns if the notifier is enabled.
Signal< int > & | activated ()
| Signal indicating an event.

## Detailed Description

A utility class for asynchronous notification of socket activity.

Use a aocket notifier to integrate listening for socket events into the Wt event loop. In this way, you do not need a separate thread to listen for socket activity. Socket activity is either the availability of data to be read (Read event), possibility to write data (Write event), or an exception that occurred (Exception event).

When an event on a socket is available, the notifier emits the activated() signal. As in the case of a user interface event (like for example WInteractWidget::clicked()), you will typically modify the widget tree in response to the event. But, unless you use a timer (WTimer) or use server-initiated updates (see WApplication::triggerUpdates()), these changes are not propagated to the user interface, until the next user interface event.

Like other events, socket notification events are serial (not simultaneous), and there are no thread safety issues (you don't need to take the WApplication::UpdateLock).

     Wt::WSocketNotifier *notifier_;

     void init() {
       ...
       int sock = ...
       notifier_ = new Wt::WSocketNotifier(sock, Wt::WSocketNotifier::Read, this);
       notifier_->activated().connect(this, &HelloApplication::readData);
     }

     void readData() {
       // data is available on socket, or socket was closed by peer
       char buf[100];
       int s = read(notifier_->socket(), buf, 99);

       if (s > 0) {
         ...
       } else {
         // closed by peer
         notifier_->setEnabled(false);
         close(notifier_->socket());
       }
     }

## Member Enumeration Documentation

enum Wt::WSocketNotifier::Type

Enumeration that event type.

Enumerator:

  Read | Ready to read.
  Write | Ready to write.
  Exception | Exception.

## Constructor & Destructor Documentation

Wt::WSocketNotifier::WSocketNotifier | ( | int | socket,
|  | Type | type,
|  | WObject * | parent = `0`
| ) |  |

Creates a new socket notifier.

Create a new socket listener to listen for events of given `type` on a socket with file descriptor `socket`. The WSocketNotifier is enabled after construction.

## Member Function Documentation

Signal<int>& Wt::WSocketNotifier::activated | ( |  | ) |

Signal indicating an event.

The signal is emitted when an event that was waited for is available. The signal argument is socket().

void Wt::WSocketNotifier::setEnabled | ( | bool | enabled | ) |

Enables or disable the notifier.

By default, the socket notifier is enabled to receive events. When disabled, no events will be notified (as if the socket notifier didn't exist).

All Classes Namespaces Functions Variables Typedefs Enumerations Enumerator